#!/usr/bin/env python

import sys
import time
import os
from python_sdk_api.sxd_api import *

print "[+] PFSC register access test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

pfsc = ku_pfsc_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

pfsc.local_port = 1

print "[+] Get PFSC"
sxd_access_reg_pfsc(pfsc, meta, 1, None, None)

print "[+] local port: ", pfsc.local_port

print "[+] Get PFSC content"
print "===================="
print "[+] Admin Forward: ", pfsc.fwd_admin
print "[+] Oper Forward: ", pfsc.fwd_oper

meta.access_cmd = SXD_ACCESS_CMD_SET

pfsc.fwd_admin = 1


print "[+] Set PFSC content"
print "===================="
print "[+] Admin Forward: ", pfsc.fwd_admin

print "[+] Set PFSC"
sxd_access_reg_pfsc(pfsc, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET

print "[+] Get PFSC"
sxd_access_reg_pfsc(pfsc, meta, 1, None, None)

print "[+] Get after Set PFSC content"
print "=============================="
print "[+] Admin Forward: ", pfsc.fwd_admin
print "[+] Oper Forward: ", pfsc.fwd_oper

print "[+] PFSC register access test end"
